﻿
namespace TSLab.Script.Helpers
{
    /// <summary>
    /// The chart creation helper
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public class ChartHelper<T> 
        where T : struct
    {
        private readonly T[] m_values;

        private T m_lastValue;
        private int m_lastNum;

        public ChartHelper(int size)
        {
            m_values = new T[size];
        }

        private void Fill(int to)
        {
            for(int i = m_lastNum + 1; i < to; i++)
            {
                m_values[i] = m_lastValue;
            }
            m_lastNum = to - 1;
        }

        public void SetValue(T value, int num)
        {
            Fill(num);
            m_lastValue = m_values[num] = value;
            m_lastNum = num;
        }

        public T[] ToArray()
        {
            Fill(m_values.Length);
            return m_values;
        }
    }
}
